/* Sistemas Integrados TEKNISA

Nome: 0007_LAVFUNO_USR_CONTA_DIFALIQ.SQL

@C:\Web_505\Xdb\Src\Cli\Lav\Sql\0007_LAVFUNO_USR_CONTA_DIFALIQ.SQL

Descrio:
Funo para retornar a conta contabil do diferencial de alquota.

Criao:
01/11/2010 - Cleison Rafael da Silva Ferreira
*/


create or replace function USR_CONTA_DIFALIQ
     (P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE) RETURN VARCHAR
as
   V_PRODUTO    VARCHAR2(20);
   V_CONTADA    VARCHAR2(20);
   V_CONTAREDU  VARCHAR2(20);
begin

   SELECT MAX(CDARVPROD)
     INTO V_PRODUTO
     FROM PRODUTO
    WHERE CDPRODUTO = P_CDPRODUTO;

   V_CONTADA := NULL;
   FOR C_PRODUTO IN (SELECT P.USR_CDDIFALIQ
                       FROM USR_PARAMDIFALIQ P, PRODUTO PR
                      WHERE (INSTR(V_PRODUTO, PR.CDARVPROD) = 1)
                        AND (P.USR_CDPRODUTO = PR.CDPRODUTO)
                        AND (NOT P.USR_CDDIFALIQ IS NULL)
                      ORDER BY PR.CDARVPROD DESC) LOOP
      V_CONTADA := C_PRODUTO.USR_CDDIFALIQ;
      EXIT;
   END LOOP;

   IF NOT (V_CONTADA IS NULL) THEN
      BEGIN
         SELECT CDCONTREDU
           INTO V_CONTAREDU
           FROM CONTCTBL
          WHERE CDCONTCTBL = V_CONTADA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CONTAREDU := NULL;
      END;
   END IF;

   RETURN(V_CONTAREDU);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_CONTA_DIFALIQ','5.05.000'); END;
/
